---@diagnostic disable: lowercase-global
-- QBCore = exports["qb-core"]:GetCoreObject()
locations = nil
_blip = {}
QBCore = exports["qb-core"]:GetCoreObject()
--===============================================================
--                       Commands
--===============================================================

RegisterCommand('crewMenu', function ()
    openCrewMenu()
end)


RegisterCommand('setMainBase', function (source,args)
    QBCore.Functions.TriggerCallback('lab-crew:server:getPlacesInfo', function (locationNames, drugs, settlingsBase)
        
        if locationNames ~= nil then
            if settlingsBase then
                TriggerServerEvent('lab-crew:server:setMainBase', locationNames)
            else
                crewNotify(Locales.MustBeLeader, 'error')

            end
        else
            crewNotify(Locales.MustBeField, 'error')
        end
    end, getLocationName())
end)


--===============================================================
--                       Create Zones
--===============================================================
blip_marker = {}
-- blip = {}
-- first = true
_initZone = function ()
    for k , v in pairs(Config.Locations) do
        -- if first then

            exports["bt-polyzone"]:AddPolyZone(v.mapName, v.zones, {
                minZ=v.zoneMinZ,    
                maxZ=v.zoneMaxZ,
                debugPoly = false
            })
            -- first = false
        -- end
            -- print(v["markers"]["width"])
        if Config.DisplayMarker  then
            for index, area in pairs(v["markers"]) do 
                local centerX = (area.x1 + area.x2) / 2
                local centerY = (area.y1 + area.y2) / 2
            
                local width = math.abs(area.x1 - area.x2)
                local height = math.abs(area.y1 - area.y2)
                blips = AddBlipForArea(centerX, centerY, 0.0, width, height)
                SetBlipAlpha(blips, 64)
                SetBlipAsShortRange(blips, true)
                SetBlipDisplay(blips, 3)
                -- QBCore.Functions.TriggerCallback('lab-crew:server:getAllCrewColors', function (system)
                --     for i, value in pairs(system) do
                --         SetBlipColour(blips, tonumber(value.color))
                --     end
                -- end)
                blip_marker[#blip_marker+1] = {[v.mapName] = blips}
                
            end
        end
    end
    _initMarker()
end



_initMarker = function ()
    print('initmarkr')
    QBCore.Functions.TriggerCallback('lab-crew:server:getAllCrewColors', function (system)
        for systemIndex, systemValue in pairs(system) do
            for placeIndex, placeValue in pairs(systemValue.places) do
                for blipIndex,blipValue in pairs(blip_marker) do
                    if blipValue[placeIndex] ~= nil then
                        SetBlipColour(blipValue[placeIndex], tonumber(systemValue.color))
                    end
                end
            end
        end
    end)
end


_clearAllBlips = function ()
    -- Bu kısım problemli çalışıyor galiba kontrol edilmesi gerekiyor
        for k,v in pairs(blip_marker) do
            if getLocationName() ~= nil then
                print('Removeblip=',v[getLocationName()] , getLocationName())
                if v[getLocationName()] == getLocationName() then
                    RemoveBlip(v[getLocationName()])
                end
            else
                crewNotify(Locales.MustBeField, 'error')
            end
        end
    -- blip_marker = {}
    -- Wait(1200)
    _updateZone()
end

_updateZone = function()
    for k , v in pairs(Config.Locations) do
        for index, area in pairs(v["markers"]) do 
            if getLocationName() == v.mapName then
                local centerX = (area.x1 + area.x2) / 2
                local centerY = (area.y1 + area.y2) / 2
                
                local width = math.abs(area.x1 - area.x2)
                local height = math.abs(area.y1 - area.y2)
                blips = AddBlipForArea(centerX, centerY, 0.0, width, height)
                SetBlipAlpha(blips, 64)
                SetBlipAsShortRange(blips, true)
                SetBlipDisplay(blips, 3)
                blip_marker[#blip_marker+1] = {[v.mapName] = blips}
                break
            end
        end
    end
    _initMarker()
end

AddEventHandler('bt-polyzone:enter', function(name)
    print('Entered ==> ', name)
    testText =  drawTextTemplate()
    testText.x = 0.85
    testText.y = 0.90
    inArea = true
    locations = name
    QBCore.Functions.TriggerCallback('lab-crew:server:getPlacesInfo', function (locationNames)
        testText.text = Locales.Unoccupied_Land
        if locationNames ~= nil then
            while true do
                Wait(0)
                if inArea then
                    testText.text = "You're in the "..locationNames.."'s territory"
                    drawText(testText)
                    -- Wait(120500)
                    -- inArea = false
                    -- print('clear=>',inArea)
                else
                    break
                end
            end
        else
            while true do
                Wait(0)
                if inArea then
                    testText.text = Locales.Unoccupied_Land
                    drawText(testText)
                    -- Wait(120500)
                    -- inArea = false
                    -- print('clear=>',inArea)
                else
                    break
                end
            end
        end
    end, locations, "forPlacesName")

end)

AddEventHandler('bt-polyzone:exit', function(name)
    print('Left the area ==> ', name)
    inArea = false
    locations = nil
end)


--===============================================================
--                       RegisterNUI Callback
--===============================================================
RegisterNUICallback('createCrew', function (data,cb)
    print('CreateCR',data.crewName, data.crewTag)
    if Config.Framework == "newqb" or Config.Framework == "oldqb" then
        QBCore.Functions.TriggerCallback('lab-crew:server:createCrew', function (result, message, status)
            crewNotify(message, status)
            cb(result)
            
        end, data.crewName, data.crewTag)
    elseif Config.Framework == "esx" or Config.Framework == "infinity" then
        ESX.TriggerServerCallback('lab-crew:server:createCrew', function (result, message, status)
            crewNotify(message, status)
            cb(result)
            
        end, data.crewName, data.crewTag)
    end
end)




RegisterNUICallback('sendMessage', function (data,cb)
    local PlayerData =QBCore.Functions.GetPlayerData()
    crewChat  = {}
    itemID = math.random(111111111111,999999999999)

    crewChat[itemID] = {
        ["message"] =  data.message,
        ["sender"] =  PlayerData.citizenid,
        ["firstname"] =  PlayerData.charinfo.firstname,
        ["lastname"] =  PlayerData.charinfo.lastname,
        ["time"] = data.currentMessageTime,
        ["date"] = data.currentTimeDate,
        ["img"] =  "",
    }
    TriggerServerEvent('lab-crew:server:updateMessages', crewChat,itemID)
end)



RegisterNUICallback('getPlayerList', function (elemtns,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getPlayerList', function (data,count,myimage)
        print(data,count,myimage)
        content = {players = data, count = count, max = GetConvarInt('sv_maxclients', 256), showid = showid,  myimage = myimage}
        print('content:', json.encode(content))
        cb(content)
    end)
end)


RegisterNUICallback('joinCrew', function (data,cb)
    print('joinCrew',data.crewName)
    TriggerServerEvent('lab-crew:server:joinCrew', data.crewName)
    QBCore.Functions.TriggerCallback('lab-crew:server:joinCrew', function (result)
        crewNotify(data.crewName..""..Locales.joinCrew_Message, 'success')
        closeScreen()
        cb(true)
    end, data.crewName)
end)

RegisterNUICallback('sendInvite', function (data,cb)
    TriggerServerEvent('lab-crew:server:sendInvite', data.targetID, data.currentMessageTime, data.currentTimeDate)
    print('sendInvite',data.currentMessageTime, data.currentTimeDate)
end)

RegisterNUICallback('getCrewMembers', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getCrewMembers',function (result)
        cb(result)
    end)
end)

RegisterNUICallback('getMapCrews', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getMapCrews',function (result)
        cb(result)
    end)
end)


RegisterNUICallback('kickMember', function (data,cb)
    print('Kick:crewMembers', data.playerCID,data.playerGrade,data.crewName)
    QBCore.Functions.TriggerCallback('lab-crew:server:kickMember',function (result)
        cb(result)
    end, data.playerCID,data.playerGrade,data.crewName)
end)



RegisterNUICallback('setInventory', function (data,cb)
    if locations ~= nil then
        coords = {x =  GetEntityCoords(PlayerPedId()).x,y =  GetEntityCoords(PlayerPedId()).y,z =  GetEntityCoords(PlayerPedId()).z, type = "inventory"}

        TriggerServerEvent('lab-crew:server:setInventoryCoords',coords, locations, data.inventoryPassword, getLocationName())
    else
        crewNotify(Locales.MustBeField, "error")
    end
end)


RegisterNUICallback('setGarage', function (data,cb)
    if locations ~= nil then
        coords = {x =  GetEntityCoords(PlayerPedId()).x,y =  GetEntityCoords(PlayerPedId()).y,z =  GetEntityCoords(PlayerPedId()).z, type = "garage"}
        TriggerServerEvent('lab-crew:server:setGarageCoords',coords, locations, data.garagePassword, getLocationName())
    else
        crewNotify(Locales.MustBeField, "error")
    end
end)


RegisterNUICallback('playerCheckItem', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:playerCheckItem', function (data)
        cb(data)
    end)
end)



RegisterNUICallback('addCrewInventoryItem', function (data,cb)
    addItems = {}
    addItems[data.itemName] = {
        ["name"] = data.itemName,
        ["label"] = data.itemLabel,
        ["amount"] = data.itemAmount
    }
    QBCore.Functions.TriggerCallback('lab-crew:server:addCrewInventoryItem', function (result)
        cb(result)
    end,addItems, data.itemName, data.itemAmount)
end)



RegisterNUICallback('getCrewInventory', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getCrewInventory',function (result)
        print('ggetCrewInventory',result)
        cb(result)
    end)    
end)


RegisterNUICallback('reTakeInventory', function (data,cb)
    addItems = {}
    addItems[data.itemName] = {
        ["name"] = data.itemName,
        ["label"] = data.itemLabel,
        ["amount"] = data.itemAmount
    }

    QBCore.Functions.TriggerCallback('lab-crew:server:reTakeInventory',function (result)
        cb(result)
    end,addItems,data.itemName,data.itemAmount)    
end)


RegisterNUICallback('createAnnounce', function (data,cb)

    createAnnounce  = {}
    itemID = math.random(111111111111,999999999999)

    createAnnounce[itemID] = {
        ["announceHeader"] =  data.announceHeader,
        ["announceLabel"] =  data.announceLabel,
        ["announceIMG"] =  data.announceIMG,
    }
    TriggerServerEvent('lab-crew:server:sendAnnounce', createAnnounce) 
end)


RegisterNUICallback('getCrewGarage', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:checkVehicles', function (data)
        cb(data)        
    end)
end)



RegisterNUICallback('getVehicle', function (data,cb)
    print('data.vehiclePlate', data.vehiclePlate)
    QBCore.Functions.TriggerCallback('lab-crew:server:getVehicle', function (vehicleProperty, vehicleModel,vehiclePlate)
        local model = (type(vehicleModel)=="number" and vehicleModel or GetHashKey(vehicleModel))
        local coords = coords ~= nil and coords or GetEntityCoords(PlayerPedId())
        local isnetworked = isnetworked ~= nil and isnetworked or true
    
        RequestModel(model)
        while not HasModelLoaded(model) do
            Citizen.Wait(10)
        end
        local xVehicle = CreateVehicle(model, GetEntityCoords(PlayerPedId(-1)), 187.91386, true, false)
        QBCore.Functions.SetVehicleProperties(xVehicle, vehicleProperty)
        SetVehicleNumberPlateText(xVehicle, vehiclePlate)
        SetPedIntoVehicle(PlayerPedId(), xVehicle, -1)
        TriggerEvent("vehiclekeys:client:SetOwner", GetVehicleNumberPlateText(xVehicle))

        closeScreens()
        cb(true)
    end, data.vehiclePlate)
end)


RegisterNUICallback('checkPassword', function (data,cb)
    -- burada sistemdeki şifreyi kontrol edecek eğer ki olursa acacak
    QBCore.Functions.TriggerCallback('lab-crew:server:checkPassword', function (data)
        
    end)
end)

RegisterNUICallback('confirmPassword', function (data,cb)
    if data.crewStatus == "inventory" then
        openInventory()
    elseif data.crewStatus == "garage" then
        openGarage()
    end
end)


RegisterNUICallback('createGrade', function (data,cb)
    TriggerServerEvent('lab-crew:server:createGrade', data.gradeName)
end)

RegisterNUICallback('getGrades', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getGrades', function (result)
        cb(result)
    end)
end)

local grades = {
    ["sendAnnounce"] = false,
    ["setInventory"] = false,
    ["setGarage"] = false,
    ["crewInvite"] = false,
    ["crewKickMember"] = false,
    ["crewSetColour"] = false,
    ["crewUseGarage"] = false,
    ["crewUseInventory"] = false,
    ["crewChangeGrade"] = false
}

RegisterNUICallback('addPermToGrade', function (data,cb)
    -- data.perm | data.clickedGrade  |  data.permStatus(true/false)
    perm = data.perm
    grades[""..perm..""] = true
    print('AddPermToGrade =>',json.encode(grades))
end)

RegisterNUICallback('deletePermToGrade', function (data,cb)
    perm = data.perm
    grades[""..perm..""] = false
    print('deletePermToGrade =>',json.encode(grades))
end)

RegisterNUICallback('addPermConfirm', function (data,cb)
    TriggerServerEvent('lab-crew:server:addPerm', grades, data.clickedGrade)
end)

RegisterNUICallback('setPlayerGrade', function (data,cb)
    print('setPlayerGrade',data.permLabel,data.playerCID,data.crewName)
    TriggerServerEvent('lab-crew:server:setPlayerGrade', data.permLabel, data.playerCID, data.crewName)
end)


RegisterNUICallback('getWarStatus', function (data,cb)
    QBCore.Functions.TriggerCallback('lab-crew:server:getCrewWars', function (data)
        print('getWar Status => ',json.encode(data))
        cb(data)
    end)
end)

RegisterNUICallback('returnedWarInvite', function (data,cb)
    print('returnedWarInvite', data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)
    TriggerServerEvent('lab-crew:server:returnedWarInvite',  data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)
end)

RegisterNUICallback('crewWarConfirm', function (data,cb)
    print('crewWarConfirm', data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)
    TriggerServerEvent('lab-crew:server:crewWarConfirm', data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)
end)

RegisterNUICallback('sendWarToCrew', function (data,cb)
    print('sendWarToCrew', data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)

    -- yukardıkiler savaş veya bir şeyde olmadığı için nil olarak gelecektir:

    TriggerServerEvent('lab-crew:server:sendWarToCrew', data.playercrewtag, data.currentCrewTag, data.warStatus, data.warTarget, data.warSender)
end)

RegisterNUICallback('crewGetColor', function (data,cb)
    -- print('crewGetColor:', , Utils.COLORS)
    cb(USEFUL_COLORS)
end)

RegisterNUICallback('setCrewColor', function (data,cb)
    print('client, colorID:', data.colorID,data.colorRGB)
    TriggerServerEvent('lab-crew:server:setCrewColor', data.colorID,data.colorRGB)
    -- cb(COLORS)
 
end)

RegisterNetEvent('lab-crew:client:refreshBlipMarkers')
AddEventHandler('lab-crew:client:refreshBlipMarkers', function ()
    print('==>>         refreshMARKES')
    -- blip_marker = {}
    _clearAllBlips()
end)

RegisterNetEvent('lab-crew:client:refreshMarkers')
AddEventHandler('lab-crew:client:refreshMarkers', function()
    print('==>>         Markers is redy')

    -- blip_marker = {}
    _clearAllBlips()
end)


RegisterNUICallback('disableControls',function (data,cb)
    firstDisable = not firstDisable
    print(firstDisable)
    if firstDisable then
        SetNuiFocusKeepInput(true)
        LockKeyboard = true
    else
        SetNuiFocusKeepInput(false)
        LockKeyboard = false
    end
end)
RegisterNUICallback('closeScreen', function (data,cb)
    closeScreens()
    LockKeyboard = false
    IsSpraying = false
    SprayText = ''
    SetNuiFocusKeepInput(false)
end)

--===============================================================
--                       Events
--===============================================================
RegisterNetEvent('lab-crew:client:updateMembers')
AddEventHandler('lab-crew:client:updateMembers', function ()
    SendNUIMessage({
        type = "loadCrewMember",
    })
end)

RegisterNetEvent('lab-crew:client:updateMessages')
AddEventHandler('lab-crew:client:updateMessages',function (data)
    local PlayerData =QBCore.Functions.GetPlayerData()    
    QBCore.Functions.TriggerCallback('lab-crew:server:CheckMessages', function (messageData)

        SendNUIMessage({
            type = "refreshChat",
            messageData = messageData,
            playerCID = PlayerData.citizenid,
        })
    end)
end)



RegisterNetEvent('lab-crew:client:updateInventory')
AddEventHandler('lab-crew:client:updateInventory', function ()
    SendNUIMessage({
        type = "refreshInventory",
    })
end)

RegisterNetEvent('lab-crew:client:sendNotify')
AddEventHandler('lab-crew:client:sendNotify', function (message,status)
    SendNUIMessage({
        type = "crewNotify",
        status = status,
        message = message,
    })
end)


RegisterNetEvent('lab-crew:server:clearGrades')
AddEventHandler('lab-crew:server:clearGrades', function ()
    grades = {
        ["sendAnnounce"] = false,
        ["setInventory"] = false,
        ["setGarage"] = false,
        ["crewInvite"] = false,
        ["crewKickMember"] = false,
        ["crewSetColour"] = false,
        ["crewUseGarage"] = false,
        ["crewUseInventory"] = false,
        ["crewChangeGrade"] = false,
    }
end)

--===============================================================
--                       Function
--===============================================================
RegisterKeyMapping('crewMenu', 'Crew Menu', 'keyboard', 'PAGEUP')



openCrewMenu = function ()
    QBCore.Functions.TriggerCallback('lab-crew:server:checkOwnCrew', function (result, crewData,string)
        QBCore.Functions.TriggerCallback('lab-crew:server:CheckMessages', function (messageData)
            QBCore.Functions.TriggerCallback('lab-crew:server:checkAnnounce', function (announceData)
                
                -- print(json.encode(messageData))
                local PlayerData =QBCore.Functions.GetPlayerData()  
                if result then
                    if string == "managment" then
                        SendNUIMessage({
                            type = "openCrewMenu",
                            status = string,
                            crewData = crewData,
                            messageData = messageData,
                            announceData = announceData,
                            playerCID = PlayerData.citizenid,
                            Locales = Locales,
                            -- playerList = serverList
                        })
                        SetNuiFocus(true,true)
                    else
                        SendNUIMessage({
                            type = "openCrewMenu",
                            grade = string,
                            crewData = crewData,
                            messageData = messageData,
                            announceData = announceData,
                            playerCID = PlayerData.citizenid,
                            Locales = Locales,
                            -- playerList = serverList
                        })
                        SetNuiFocus(true,true)
                    end
                else
                    print('crewe bağımlı değilsin')
                end
            end)
        end)
    end)
end


createCrew = function ()
    -- print('createCrew')
    QBCore.Functions.TriggerCallback('lab-crew:server:checkInvites', function (invites)
        print('invites')
        SetNuiFocus(true,true)
        SendNUIMessage({
            type = "createCrew",
            invites = invites
        })
    end)
end

getLocationName = function ()
    return locations
end

positons = {}
_checkMarker = function ()
    print('Function detc')
    -- if not HasStreamedTextureDictLoaded("marker") then
    QBCore.Functions.TriggerCallback('lab-crew:server:checkMarkers', function (markerSide)
        print('CheckMarkers:')
    positons = markerSide
    -- else
        while true do
            local sleepThread = 500


            for i  =1 , #positons do   
                local pedCoords = GetEntityCoords(PlayerPedId())	
                -- print(positons[i].x,positons[i].y,positons[i].z)
                local coords = vector3(positons[i].x,positons[i].y,positons[i].z)
                local dstCheck = #(pedCoords - coords)
                if dstCheck <= Config.MarkerData["range"] then
                    sleepThread = 0
                    if not HasStreamedTextureDictLoaded("marker") then
                        RequestStreamedTextureDict("marker", true)
                        while not HasStreamedTextureDictLoaded("marker") do
                            Wait(1)
                        end
                    else
                        if dstCheck <= Config.MarkerData["size"]["x"] - 0.35 then
                            if IsControlJustPressed(0, 38)  then
                                if positons[i].type == "inventory" then
                                    getPassword("inventory")
                                    -- openInventory()
                                else
                                    getPassword("garage")
                                    
                                    -- openGarage()
                                end
                            end
                        end
                    end
                    DrawMarker(9, positons[i].x,positons[i].y,positons[i].z + 0.28, 0.0, 0.0, 0.0, 100.0, 0.0, 0.0, 0.6, 0.6, 0.6, 255,255,255, 255,false, false, 2, true, "marker", positons[i].type, false)                            
                end
            end
            Citizen.Wait(sleepThread)
        end
    end)
end

RegisterNetEvent('lab-crew:client:deleteMarker') -- aynısı garaj için  de yapılacak
AddEventHandler('lab-crew:client:deleteMarker', function (oldPositionX)
    positons = {}
    _checkMarker()
    print('deleteMarker')
end)

function noSpace(str)
	local normalisedString = string.gsub(str, "%s+", "")
	return normalisedString
end

crewNotify = function(message, status)
    SendNUIMessage({
        type = "crewNotify",
        status = status,
        message = message,
        Locales = Locales,

    })
end


getPassword = function (status)
    QBCore.Functions.TriggerCallback('lab-crew:server:getPassword', function (password)
        
        SendNUIMessage({
            type = "openPassword",
            status = status,
            password = password,
            Locales = Locales,
        })
        SetNuiFocus(true,true)
        
    end, status, getLocationName())
end


openGarage = function ()
    
    -- elindeki aracı silip aracı kayıt edecek
    veh = GetVehiclePedIsIn(PlayerPedId())
    Wait(200)
    if veh ~= 0 then 
        print('veh_Propertys',QBCore.Functions.GetVehicleProperties(veh), GetVehicleNumberPlateText(veh))
       TriggerServerEvent("lab-crew:server:saveGarageVehicle", QBCore.Functions.GetVehicleProperties(veh), GetVehicleNumberPlateText(veh), GetDisplayNameFromVehicleModel(GetEntityModel(GetVehiclePedIsIn(GetPlayerPed(-1)))), GetLabelText(GetDisplayNameFromVehicleModel(GetEntityModel(GetVehiclePedIsIn(GetPlayerPed(-1))))))
       DeleteVehicle(veh)
       SetNuiFocus(false,false)
    else
        QBCore.Functions.TriggerCallback('lab-crew:server:checkOwnCrew', function (result, crewData,string)
            QBCore.Functions.TriggerCallback('lab-crew:server:CheckMessages', function (messageData)                -- print(json.encode(messageData))
                QBCore.Functions.TriggerCallback('lab-crew:server:checkAnnounce', function (announceData)
                
                    local PlayerData =QBCore.Functions.GetPlayerData()    
                    if result then
                        if string == "managment" then
                            SendNUIMessage({
                                type = "openGarage",
                                status = string,
                                crewData = crewData,
                                messageData = messageData,
                                announceData = announceData,
                                playerCID = PlayerData.citizenid,
                                Locales = Locales,
                                -- playerList = serverList
                            })
                            SetNuiFocus(true,true)
                        else
                            SendNUIMessage({
                                type = "openGarage",
                                grade = string,

                                crewData = crewData,
                                messageData = messageData,
                                announceData = announceData,
                                playerCID = PlayerData.citizenid,
                                Locales = Locales,
                                -- playerList = serverList
                            })
                            SetNuiFocus(true,true)
                        end
                    else
                        print('crewe bağımlı değilsin')
                    end
                end)
            end)
        end)
    end 
end

openInventory = function()
    QBCore.Functions.TriggerCallback('lab-crew:server:checkOwnCrew', function (result, crewData,string)
        QBCore.Functions.TriggerCallback('lab-crew:server:CheckMessages', function (messageData)                -- print(json.encode(messageData))
            QBCore.Functions.TriggerCallback('lab-crew:server:checkAnnounce', function (announceData)

                local PlayerData =QBCore.Functions.GetPlayerData()    
                if result then
                    if string == "managment" then
                        SendNUIMessage({
                            type = "openInventory",
                            status = string,
                            crewData = crewData,
                            messageData = messageData,
                            announceData = announceData,
                            playerCID = PlayerData.citizenid,
                            inventory = inventory,
                            Locales = Locales,
                        })
                        SetNuiFocus(true,true)
                    else
                        SendNUIMessage({
                            type = "openInventory",
                            grade = string,
                            crewData = crewData,
                            messageData = messageData,
                            announceData = announceData,
                            playerCID = PlayerData.citizenid,
                            inventory = inventory,
                            Locales = Locales,
                        })
                        SetNuiFocus(true,true)
                    end
                else
                    print('crewe bağımlı değilsin')
                end
            end)
        end)
    end)
end




closeScreen = function ()
    SendNUIMessage({
        type = "closeScreen",
    })
    SetNuiFocus(false, false)
end

closeScreens = function ()
    LockKeyboard = false
    IsSpraying = false
    SprayText = ''
    SetNuiFocusKeepInput(false)
    print('closed screen')
    -- SendNUIMessage({
    --     type = "closeScreen",
    -- })
    SetNuiFocus(false, false)
end

TableCopy = function(tab)
  local r = {}
  for k,v in pairs(tab) do
    if type(v) == "table" then
      r[k] = TableCopy(v)
    else
      r[k] = v
    end
  end
  return r
end


--===============================================================
--                       NPC Creator
--===============================================================
SpawnNpcs = function ()
    Citizen.CreateThread(function()
        local npc = CreatePed(4, GetHashKey("mp_m_freemode_01"),  Config.BossNPC.x,Config.BossNPC.y,Config.BossNPC.z-1, Config.BossNPC_Heading, false, true)
        SetPedComponentVariation(npc, 11, 182, 0, 2)
        SetPedComponentVariation(npc, 2, math.random(0,76), 0, 2)
    
        SetPedComponentVariation(npc, 6, 10, 0, 2)
        SetPedComponentVariation(npc, 4, 10, 0, 2)
        SetPedComponentVariation(npc, 8, 15, 0, 2)
        SetPedPropIndex(npc, 0, 136, 1, true)
        SetPedPropIndex(npc, 1, 5, 0, true)

        SetPedHeadBlendData(npc, math.random(0,10), math.random(0,10), 0, math.random(0,10), math.random(0,10), 0, 5, 4, 0.0, false)
        SetPedFaceFeature(npc, 0,  (math.random(1) / 100)         + 0.0)  -- Nose Width
        SetPedFaceFeature(npc, 1,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Height
        SetPedFaceFeature(npc, 2,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Length
        SetPedFaceFeature(npc, 3,  (math.random(0,10) / 100)         + 0.0)  -- Nose Bone Height
        SetPedFaceFeature(npc, 4,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Lowering
        SetPedFaceFeature(npc, 5,  (math.random(0,10) / 100)         + 0.0)  -- Nose Bone Twist
        SetPedFaceFeature(npc, 6,  (math.random(0,10) / 100)     + 0.0)  -- Eyebrow height
        SetPedFaceFeature(npc, 7,  (math.random(0,10) / 100)     + 0.0)  -- Eyebrow depth
        SetPedFaceFeature(npc, 8,  (math.random(0,10) / 100)       + 0.0)  -- Cheekbones Height
        SetPedFaceFeature(npc, 9,  (math.random(0,10) / 100)       + 0.0)  -- Cheekbones Width
        SetPedFaceFeature(npc, 10, (math.random(0,10) / 100)       + 0.0)  -- Cheeks Width
        SetPedFaceFeature(npc, 11, (math.random(0,10) / 100)     + 0.0)  -- Eyes squint
        SetPedFaceFeature(npc, 12, (math.random(0,10) / 100)  + 0.0)  -- Lip Fullness
        SetPedFaceFeature(npc, 13, (math.random(0,10) / 100)          + 0.0)  -- Jaw Bone Width
        SetPedFaceFeature(npc, 14, (math.random(0,10) / 100)          + 0.0)  -- Jaw Bone Length
        SetPedFaceFeature(npc, 15, (math.random(0,10) / 100)         + 0.0)  -- Chin Height
        SetPedFaceFeature(npc, 16, (math.random(0,10) / 100)         + 0.0)  -- Chin Length
        SetPedFaceFeature(npc, 17, (math.random(0,10) / 100)         + 0.0)  -- Chin Width
        SetPedFaceFeature(npc, 18, (math.random(0,10) / 100)         + 0.0)  -- Chin Hole Size
        SetPedFaceFeature(npc, 19, (math.random(0,10) / 100) + 0.0)  -- Neck Thickness
        FreezeEntityPosition(npc, true)	
        SetEntityInvincible(npc, true)
        SetBlockingOfNonTemporaryEvents(npc, true)
        RequestAnimDict("anim@amb@nightclub@peds@")
        
        while not HasAnimDictLoaded("anim@amb@nightclub@peds@") do
            Citizen.Wait(1000)
        end
        TaskPlayAnim(npc,"anim@amb@nightclub@peds@","amb_world_human_stand_guard_male_base",1.0, 1.0, -1, 9, 1.0, 0, 0, 0)
    
        while npc == 0 do
            Citizen.Wait(200)
            RequestModel(GetHashKey("mp_m_freemode_01"))
    
            while not HasModelLoaded(GetHashKey("mp_m_freemode_01")) do
                Wait(1)
            end
            npc = CreatePed(4, GetHashKey("mp_m_freemode_01"),  Config.BossNPC.x,Config.BossNPC.y,Config.BossNPC.z-1, Config.BossNPC_Heading, false, true)
            SetPedComponentVariation(npc, 11, 182, 0, 2)
            SetPedComponentVariation(npc, 2, math.random(0,76), 0, 2)
        
            SetPedComponentVariation(npc, 6, 10, 0, 2)
            SetPedComponentVariation(npc, 4, 10, 0, 2)
            SetPedComponentVariation(npc, 8, 15, 0, 2)
            SetPedPropIndex(npc, 0, 136, 1, true)
            SetPedPropIndex(npc, 1, 5, 0, true)
    
            SetPedHeadBlendData(npc, math.random(0,10), math.random(0,10), 0, math.random(0,10), math.random(0,10), 0, 5, 4, 0.0, false)
            SetPedFaceFeature(npc, 0,  (math.random(1) / 100)         + 0.0)  -- Nose Width
            SetPedFaceFeature(npc, 1,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Height
            SetPedFaceFeature(npc, 2,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Length
            SetPedFaceFeature(npc, 3,  (math.random(0,10) / 100)         + 0.0)  -- Nose Bone Height
            SetPedFaceFeature(npc, 4,  (math.random(0,10) / 100)         + 0.0)  -- Nose Peak Lowering
            SetPedFaceFeature(npc, 5,  (math.random(0,10) / 100)         + 0.0)  -- Nose Bone Twist
            SetPedFaceFeature(npc, 6,  (math.random(0,10) / 100)     + 0.0)  -- Eyebrow height
            SetPedFaceFeature(npc, 7,  (math.random(0,10) / 100)     + 0.0)  -- Eyebrow depth
            SetPedFaceFeature(npc, 8,  (math.random(0,10) / 100)       + 0.0)  -- Cheekbones Height
            SetPedFaceFeature(npc, 9,  (math.random(0,10) / 100)       + 0.0)  -- Cheekbones Width
            SetPedFaceFeature(npc, 10, (math.random(0,10) / 100)       + 0.0)  -- Cheeks Width
            SetPedFaceFeature(npc, 11, (math.random(0,10) / 100)     + 0.0)  -- Eyes squint
            SetPedFaceFeature(npc, 12, (math.random(0,10) / 100)  + 0.0)  -- Lip Fullness
            SetPedFaceFeature(npc, 13, (math.random(0,10) / 100)          + 0.0)  -- Jaw Bone Width
            SetPedFaceFeature(npc, 14, (math.random(0,10) / 100)          + 0.0)  -- Jaw Bone Length
            SetPedFaceFeature(npc, 15, (math.random(0,10) / 100)         + 0.0)  -- Chin Height
            SetPedFaceFeature(npc, 16, (math.random(0,10) / 100)         + 0.0)  -- Chin Length
            SetPedFaceFeature(npc, 17, (math.random(0,10) / 100)         + 0.0)  -- Chin Width
            SetPedFaceFeature(npc, 18, (math.random(0,10) / 100)         + 0.0)  -- Chin Hole Size
            SetPedFaceFeature(npc, 19, (math.random(0,10) / 100) + 0.0)  -- Neck Thickness
            FreezeEntityPosition(npc, true)	
            SetEntityInvincible(npc, true)
            SetBlockingOfNonTemporaryEvents(npc, true)
            RequestAnimDict("anim@amb@nightclub@peds@")
    
            while not HasAnimDictLoaded("anim@amb@nightclub@peds@") do
                Citizen.Wait(1000)
            end
            TaskPlayAnim(npc,"anim@amb@nightclub@peds@","amb_world_human_stand_guard_male_base",1.0, 1.0, -1, 9, 1.0, 0, 0, 0)
        end
    end)
end

--===============================================================
--                       Draw Marker
--===============================================================
DrawScriptMarker = function(markerData)
    DrawMarker(markerData["type"] or 1, markerData["pos"] or vector3(0.0, 0.0, 0.0), 0.0, 0.0, 0.0, (markerData["type"] == 6 and -90.0 or markerData["rotate"] and -180.0) or 0.0, 0.0, 0.0, markerData["size"] or vector3(1.0, 1.0, 1.0), markerData["color"] or vector3(150, 150, 150), 100, false, true, 2, false, false, false, false)

end

drawTextTemplate = function(
    text,
    x,
    y,
    font,
    scale1,
    scale2,
    colour1,
    colour2,
    colour3,
    colour4,
    wrap1,
    wrap2,
    centre,
    outline,
    dropshadow1,
    dropshadow2,
    dropshadow3,
    dropshadow4,
    dropshadow5,
    edge1,
    edge2,
    edge3,
    edge4,
    edge5)
    return {
        text = "",
        x = -1,
        y = -1,
        font = font or 6,
        scale1 = scale1 or 0.5,
        scale2 = scale2 or 0.5,
        colour1 = colour1 or 255,
        colour2 = colour2 or 255,
        colour3 = colour3 or 255,
        colour4 = colour4 or 255,
        wrap1 = wrap1 or 0.0,
        wrap2 = wrap2 or 1.0,
        centre = (type(centre) ~= "boolean" and true or centre),
        outline = outline or 1,
        dropshadow1 = dropshadow1 or 2,
        dropshadow2 = dropshadow2 or 0,
        dropshadow3 = dropshadow3 or 0,
        dropshadow4 = dropshadow4 or 0,
        dropshadow5 = dropshadow5 or 0,
        edge1 = edge1 or 255,
        edge2 = edge2 or 255,
        edge3 = edge3 or 255,
        edge4 = edge4 or 255,
        edge5 = edge5 or 255
    }
end
AreaBlip = function(x,y,z,width,height,heading,color,alpha,highDetail,display,shortRange,mapName)
    blip = AddBlipForArea((x or 0.0),(y or 0.0),(z or 0.0),(width or 100.0),(height or 100.0))
    SetBlipColour(blip, (color or 1))
    SetBlipAlpha (blip, 128)
    SetBlipHighDetail(blip, (highDetail or true))
    SetBlipRotation(blip, (heading or 0.0))
    SetBlipDisplay(blip, (display or 4))
    SetBlipAsShortRange(blip, (shortRange or true))
    print('AreaBlip=>', shortRange, mapName)
    return {
      handle = blip,
      x = (x or 0.0),
      y = (y or 0.0),
      z = (z or 0.0),
      width = (width or 100.0),
      display = (display or 4),
      height = (height or 100.0),
      heading = (heading or 0.0),
      color = (color or 1),
      alpha = 128,
      highDetail = (highDetail or true),
      pos = vector3((x or 0.0),(y or 0.0),(z or 0.0)),
      mapName = shortRange or nil
    }
  end



drawText = function(t)
    if not t or not t.text or t.text == "" or t.x == -1 or t.y == -1 then
        return
    end
    -- RegisterFontFile('PricedownGTAVInt')
    -- fontId = RegisterFontId('PricedownGTAVInt')
    SetTextFont(1)
    SetTextScale(t.scale1, t.scale2)
    SetTextColour(t.colour1, t.colour2, t.colour3, t.colour4)
    SetTextWrap(t.wrap1, t.wrap2)
    SetTextCentre(t.centre)
    SetTextOutline(t.outline)
    SetTextDropshadow(t.dropshadow1, t.dropshadow2, t.dropshadow3, t.dropshadow4, t.dropshadow5)
    SetTextEdge(t.edge1, t.edge2, t.edge3, t.edge4, t.edge5)
    SetTextEntry("STRING")
    AddTextComponentSubstringPlayerName(t.text)
    DrawText(t.x, t.y)
end





print("function.lua finshed 'zhonnz#2373")