cachedData = {
	["attachedComponents"] = {}
}

QBCore = exports["qb-core"]:GetCoreObject()

-- QBCore = exports["qb-core"]:GetCoreObject()

markerPosition = Config.Marker
Citizen.CreateThread(function()
	Citizen.Wait(500) -- Init time.
	if Config.StoreBlips then
		for shopIndex, shopData in ipairs(Config.Shops) do
			local storeBlip = AddBlipForCoord(shopData["clerkMarker"]["position"])
	
			SetBlipSprite(storeBlip, 52)
			SetBlipScale(storeBlip, 1.0)
			SetBlipColour(storeBlip, 2)
			SetBlipAsShortRange(storeBlip, true)
		
			BeginTextCommandSetBlipName("STRING")
			AddTextComponentString(shopData["name"])
			EndTextCommandSetBlipName(storeBlip)
		end
	end
	while true do
		local sleepThread = 500
		local ped = cachedData["ped"]
		local pedCoords = GetEntityCoords(ped)	
		local dstCheck = #(pedCoords - markerPosition)
		if dstCheck <= Config.MarkerData["range"] then
			sleepThread = 5
			if dstCheck <= Config.MarkerData["size"]["x"] - 0.35 then
				if IsControlJustPressed(0, 38)  then
					createCrew()
				end
			end
			DrawScriptMarker({
				["type"] = Config.MarkerData["type"],
				["size"] = Config.MarkerData["size"],
				["color"] = Config.MarkerData["color"],
				["pos"] = markerPosition - vector3(0.0, 0.0, 0.985)
			})
		end		
		Citizen.Wait(sleepThread)
	end
	-- end)
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(1500)

		local ped = PlayerPedId()

		if cachedData["ped"] ~= ped then
			cachedData["ped"] = ped
		end
	end
end)


RegisterCommand('+load', function ()
    SpawnNpcs()
	_initZone()
	_checkMarker()
    Wait(1200)
    TriggerServerEvent('lab-crew:playerSpawned')
    Wait(1200)
    TriggerServerEvent('lab-crew:server:playerloaded')
end)

RegisterNetEvent('QBCore:Client:OnPlayerLoaded')
AddEventHandler('QBCore:Client:OnPlayerLoaded', function ()
    SpawnNpcs()
	_initZone()
	_checkMarker()
    Wait(1200)
    TriggerServerEvent('lab-crew:playerSpawned')
    Wait(1200)
    TriggerServerEvent('lab-crew:server:playerloaded')
end)

--===============================================================
--                       GPS
--===============================================================

local blips = {}

function CreateBlipThread()
	retval = true
	Citizen.CreateThread(function()
		while true do
			Citizen.Wait(Config.UpdateTick)
			if not retval then
				return
			end
			QBCore.Functions.TriggerCallback("lab-crew:server:getData", function(Units)
				Wait(10)
				QBCore.Functions.TriggerCallback('lab-crew:server:checkItem', function (result)
                    -- print(result)
					if result then
						CreateBlips(Units)
					else
						TriggerServerEvent("lab-crew:client:dropGPS")
					end
				end, Config.GPSItem,1)
				
			end)
		end
	end)
end

RegisterNetEvent("lab-crew:client:connectGps")
AddEventHandler("lab-crew:client:connectGps", function()
	CreateBlipThread()
end)

RegisterNetEvent("lab-crew:client:dropGPS")
AddEventHandler("lab-crew:client:dropGPS", function(id)
	if id == GetPlayerServerId(PlayerId()) then
		retval = false
		RemoveExistingBlips()
	end
	if blips[id] then
		RemoveBlip(blips[id])
		blips[id] = nil
	end
end)

function CreateBlips(Units)
    -- print('CreateBlips!:',Units)
	for k,v in pairs(Units) do
        print(v.crewName == getPlayerCrewName(), v.crewName ,'>><<', getPlayerCrewName())
        if v.crewName == getPlayerCrewName() then

                if v ~= nil then
                    local blip
                    -- print('createBlips:',k)
                    if k ~= GetPlayerServerId(PlayerId()) or Config.ShowYourself then
                    if not DoesBlipExist(blips[k]) then
                        blip = AddBlipForCoord(v.coords.x, v.coords.y, v.coords.z)
                        -- SetBlipShowCone(blip, true)
                        -- SetPedAiBlipHasCone(blip ,true)
                        blips[k] = blip
                    else
                        SetBlipCoords(blips[k], v.coords.x, v.coords.y, v.coords.z)
                    end
                    SetBlipSprite(blips[k], v.sprite)
                    SetBlipColour(blips[k], tonumber(v.color))
                    SetBlipScale(blips[k], 0.8)
                    SetBlipAsShortRange(blips[k], true)
                    BeginTextCommandSetBlipName("STRING")
                    if v.leaderStatus == "Leader" then
                        AddTextComponentString(v.code ~= nil and "[LEADER] ".. v.code..  " | "..v.name or Config.Locales["unknown"]..  " | "..v.name)
                    else
                        AddTextComponentString(v.code ~= nil and "["..v.leaderStatus.."] ".. v.code..  " | "..v.name or Config.Locales["unknown"]..  " | "..v.name)
                    end

                    EndTextCommandSetBlipName(blips[k])
                end
            else
            end
			
		end
	end
end

getPlayerCrewName = function()
    QBCore.Functions.TriggerCallback('lab-crew:server:getCrewName', function(result)
        -- print('getCrewName', result)
        lastResults  = result
    end)
    return lastResults
end

function RemoveExistingBlips()
	for k,v in pairs(blips) do
		if DoesBlipExist(v) then
			RemoveBlip(v)
			blips[k] = nil
		end
	end
end











--===============================================================
--                       Take Corner
--===============================================================



local holding, npcfound, areafound, resume, cancelcorner = false, false, false, false, false
local radius = 0
local areacoord, id = nil, nil

local npcModels = {
    "a_f_y_hipster_02",
    "a_f_y_vinewood_02",
    "a_m_m_hillbilly_02",
    "a_m_o_soucent_02",
    "a_m_o_tramp_01",

}


RegisterCommand("holdcorner", function(source, args)
    local playerPed = PlayerPedId()
    if not IsPedInAnyVehicle(playerPed) and not IsPedInAnyBoat(playerPed) and not IsPedInAnyHeli(playerPed) and not IsPedInAnyPlane(playerPed) then
        if not holding then
            if args[1] == nil then
				crewNotify(Locales.QuantityCannotEmpty, 'error')

            elseif tonumber(args[1]) < 1 then
				crewNotify(Locales.QuantiyNegativeNumber, 'error')
            elseif tonumber(args[1]) > tonumber(Config.DrugSell_maxQuantiy) then
				crewNotify(Locales.MaxQuantiy, 'error')
            else
                holding = true
                itemCount = args[1]
                TriggerEvent("lab-crew:StartCorner")
            end
        else
			crewNotify(Locales.StartDrugSelling, 'error')
		end
    else
		crewNotify(Locales.CannotInVehicle, 'error')
	end
end)

RegisterCommand("cornercancel", function()
    DeleteEntity(npcPED)
    holding = false
    areafound = false
    areacoord = nil
    npcfound = false
    id = 0
    radius = 0
    npcPED = nil
    cancelcorner = true
end)


Citizen.CreateThread(function()
    while true do
        local sleep = 1000
        local playerPed = PlayerPedId()
        local playerCoord = GetEntityCoords(playerPed)
        if holding then
            sleep = 1
            for k,v in pairs(Config.Corners) do
                local dst = #(playerCoord - v.coord)
                if dst < v.radius then
                    areacoord = v.coord
                    areafound = true
                    id = k
                    radius = v.radius
                   -- print(areacoord, areafound, id, radius)
                end
            end
            if areafound then
                if not npcfound then
                    randomItem = Config.Corners[id].items[math.random(1, #Config.Corners[id].items)]
                    randomMoney = math.random(Config.Corners[id].minMoney, Config.Corners[id].maxMoney)
                    itemname = Config.ItemsName[randomItem]
                    local randomModel = npcModels[math.random(1, #npcModels)]
                    local hash = GetHashKey(randomModel)
                    local coord = Config.Corners[id].spawnpoints[math.random(1, #Config.Corners[id].spawnpoints)]
                    RequestModel(hash)
                    while not HasModelLoaded(hash) do Citizen.Wait(10) end
                    npcPED = CreatePed(4, hash, coord.x, coord.y, coord.z, false, false)
                    Citizen.Wait(math.random(5000,8000))
                    -- ESX.ShowNotification("Customer found, moving towards you.")
					crewNotify(Locales.CustomerFound, 'success')
					TaskGoToEntity(npcPED, playerPed, -1, 3.0, 1.0, 1073741824, 0)
                    --AddBlipForCoord(coord.x, coord.y, coord.z, 0, 0)
                    npcfound = true
                end
                playerCoord = GetEntityCoords(playerPed)
                pedCoord = GetEntityCoords(npcPED)
                pedst = #(playerCoord - pedCoord)
              --  print(pedst, npcPED, pedCoord)
                if pedst <= 3 then
                    resume = true
                    FreezeEntityPosition(npcPED, true)
                    DrawText3Ds(pedCoord.x, pedCoord.y, pedCoord.z+1.0, 0.40, "~g~[E]~w~ Sell "..itemCount.."x "..itemname.. " $".. randomMoney.." ~r~[H]~w~ Hire")
                else
                    FreezeEntityPosition(npcPED, false)
                    if resume then
                        TaskGoToEntity(npcPED, playerPed, -1, 3.0, 1.0, 1073741824, 0)
                        resume = false
                    end
                end
            else
				crewNotify(Locales.CannotHoldACornerHere, 'error')
				holding = false
                areafound = false
                areacoord = nil
                npcfound = false
                id = 0
                radius = 0
                cancelcorner = true
            end
        end
        if areafound then
            local pedDistance = #(playerCoord - areacoord)
            if pedDistance > radius then
                -- ESX.ShowNotification("Corner canceled because you walked away from the zone")
				crewNotify(Locales.GoingAway, 'error')
                holding = false
                areafound = false
                areacoord = nil
                npcfound = false
                id = 0
                radius = 0
                DeleteEntity(npcPED)
                npcPED = nil
            end
        end
        if HasEntityBeenDamagedByAnyPed(npcPED) then
            -- ESX.ShowNotification("He doesn't want to take anything from you for battering the buyer! You are looking for new customers.")
			crewNotify(Locales.NPCDamaged, 'error')
			newPed = npcPED
            FreezeEntityPosition(newPed, false)
            TaskWanderStandard(newPed, 1, 10)
            npcPED = nil
            npcfound = false
            Citizen.Wait(15000)
            DeleteEntity(newPed)
            newPed = nil
        end
        Citizen.Wait(sleep)
    end
end)

RegisterNetEvent("lab-crew:StartCorner")
AddEventHandler("lab-crew:StartCorner", function()
    while true do
        local playerPed = PlayerPedId()
		if npcfound then
			if IsControlJustPressed(0, 74) and pedst <= 2 then
				newPed = npcPED
				FreezeEntityPosition(newPed, false)
				TaskWanderStandard(newPed, 1, 10)
				-- ESX.ShowNotification("You are looking for new customers")
				crewNotify(Locales.LookingNewCustomer, 'error')
				npcPED = nil
				npcfound = false
				Citizen.Wait(15000)
				DeleteEntity(newPed)
				newPed = nil
			elseif IsControlJustPressed(0, 38) and pedst <= 2 then
				QBCore.Functions.TriggerCallback("lab-crew:server:checkItem", function(output) 
                    QBCore.Functions.TriggerCallback('lab-crew:server:getPlacesInfo', function (locationName,drugSaler_Upgrade)
                        -- if locationName ~= nil then
                            if output then
                                npcheading = GetEntityHeading(npcPED)
                                SetEntityHeading(playerPed, npcheading+180)
                                animasyon(playerPed, "mp_common", "givetake1_a")
                                animasyon(npcPED, "mp_common", "givetake1_a")
                                TriggerServerEvent("lab-crew:removeItem", randomItem, itemCount)
                                print('drugSaler_Upgrade',drugSaler_Upgrade)
                                if drugSaler_Upgrade then
                                    TriggerServerEvent("lab-crew:giveMoney", randomMoney + randomMoney)
                                else
                                    TriggerServerEvent("lab-crew:giveMoney", randomMoney)
                                end
                                Citizen.Wait(1000)
                                newPed = npcPED
                                FreezeEntityPosition(newPed, false)
                                TaskWanderStandard(newPed, 1, 10)
                                npcPED = nil
                                npcfound = false
                                Citizen.Wait(15000)
                                DeleteEntity(newPed)
                                newPed = nil
                            else
                                animasyon(playerPed, "gestures@m@standing@casual", "gesture_damn")
                                newPed = npcPED
                                FreezeEntityPosition(newPed, false)
                                TaskWanderStandard(newPed, 1, 10)
                                -- ESX.ShowNotification("The customer did not like you because you did not have the goods...")
                                crewNotify(Locales.NonDrugItem, 'error')
                                npcPED = nil
                                npcfound = false
                                Citizen.Wait(15000)
                                DeleteEntity(newPed)
                                newPed = nil
                            end
                        -- end
                    end, locations)
				end, randomItem, tonumber(itemCount))
			end
			if cancelcorner then
				cancelcorner = false
				break
			end
		end
        Citizen.Wait(1)
    end
end)

DrawText3Ds = function(x, y, z, scale, text)
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local px, py, pz = table.unpack(GetGameplayCamCoords())
    -- local scale = 0.35
    if onScreen then
        SetTextScale(scale, scale)
        SetTextFont(4)
        SetTextProportional(1)
        SetTextColour(255, 255, 255, 215)
        SetTextDropshadow(0)
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x, _y)
        local factor = (string.len(text)) / 490
        --DrawRect(_x, _y + 0.0120, 0.0 + factor, 0.025, 41, 11, 41, 100)
    end
end

function animasyon(ped, dict, anim)
    RequestAnimDict(dict)
	while not HasAnimDictLoaded(dict) do
		Citizen.Wait(0)
	end
	TaskPlayAnim(ped, dict, anim, 8.0, -8.0, -1, 0, 0, 0, 0, 0)
end

dt = function(table, nb)
    if nb == nil then
        nb = 0
    end

    if type(table) == 'table' then
        local s = ''
        for i = 1, nb + 1, 1 do
            s = s .. "    "
        end

        s = '{\n'
        for k,v in pairs(table) do
            if type(k) ~= 'number' then k = '"'..k..'"' end
            for i = 1, nb, 1 do
                s = s .. "    "
            end
            s = s .. '['..k..'] = ' .. dt(v, nb + 1) .. ',\n'
        end

        for i = 1, nb, 1 do
            s = s .. "    "
        end

        return s .. '}'
    else
        return tostring(table)
    end
end