-- --------------------------------------------------------
-- Sunucu:                       127.0.0.1
-- Sunucu sürümü:                10.4.24-MariaDB - mariadb.org binary distribution
-- Sunucu İşletim Sistemi:       Win64
-- HeidiSQL Sürüm:               12.0.0.6468
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- rct için veritabanı yapısı dökülüyor
CREATE DATABASE IF NOT EXISTS `rct` /*!40100 DEFAULT CHARACTER SET utf8mb4 */;
USE `rct`;

-- tablo yapısı dökülüyor rct.lab_crews
CREATE TABLE IF NOT EXISTS `lab_crews` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` varchar(50) NOT NULL,
  `crewTag` varchar(50) NOT NULL,
  `crewLeader` varchar(50) NOT NULL,
  `crewMainBase` varchar(50) DEFAULT NULL,
  `crewGrade` longtext NOT NULL DEFAULT '{"Rookie":{"sendAnnounce":false,"crewUseGarage":false,"crewInvite":false,"crewChangeGrade":false,"crewUseInventory":false,"crewSetColour":false,"crewKickMember":false,"setGarage":false,"setInventory":false}}',
  `crewMember` longtext DEFAULT NULL,
  `crewCase` int(11) unsigned NOT NULL DEFAULT 0,
  `crewInventoryCoords` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT 'vector3(0,0,0)',
  `crewGarageCoords` varchar(255) NOT NULL DEFAULT 'vector3(0,0,0)',
  `crewInventory` longtext DEFAULT NULL,
  `inventoryPassword` varchar(50) NOT NULL DEFAULT '0000',
  `crewGarage` longtext NOT NULL,
  `garagePassword` varchar(50) NOT NULL DEFAULT '0000',
  `crewColourID` varchar(50) DEFAULT '1',
  `crewColourHex` varchar(50) DEFAULT '0,0,0',
  `crewPlaces` longtext NOT NULL DEFAULT '[]',
  `crewIMG` longtext NOT NULL DEFAULT 'https://cdn.discordapp.com/attachments/938533769210654780/998130701994049606/IMG_4664.png',
  PRIMARY KEY (`id`),
  UNIQUE KEY `crewName` (`crewName`),
  UNIQUE KEY `crewTag` (`crewTag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crews: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crews`;

-- tablo yapısı dökülüyor rct.lab_crew_announcements
CREATE TABLE IF NOT EXISTS `lab_crew_announcements` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` varchar(50) DEFAULT NULL,
  `sender` varchar(50) DEFAULT NULL,
  `announcements` longtext DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  KEY `int` (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crew_announcements: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_announcements`;

-- tablo yapısı dökülüyor rct.lab_crew_garage
CREATE TABLE IF NOT EXISTS `lab_crew_garage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` varchar(50) NOT NULL,
  `vehiclePlate` varchar(50) NOT NULL,
  `vehicleLabel` varchar(50) NOT NULL,
  `vehicleModel` varchar(50) DEFAULT NULL,
  `vehicleProperties` longtext NOT NULL,
  `date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  UNIQUE KEY `vehiclePlate` (`vehiclePlate`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crew_garage: ~1 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_garage`;

-- tablo yapısı dökülüyor rct.lab_crew_invites
CREATE TABLE IF NOT EXISTS `lab_crew_invites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` varchar(50) DEFAULT NULL,
  `targetPlayer` varchar(50) DEFAULT NULL,
  `sender` varchar(50) DEFAULT NULL,
  `sendDate` varchar(50) DEFAULT NULL,
  `sendTime` longtext DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crew_invites: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_invites`;

-- tablo yapısı dökülüyor rct.lab_crew_messages
CREATE TABLE IF NOT EXISTS `lab_crew_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` mediumtext NOT NULL,
  `messages` longtext NOT NULL,
  `date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crew_messages: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_messages`;

-- tablo yapısı dökülüyor rct.lab_crew_sides
CREATE TABLE IF NOT EXISTS `lab_crew_sides` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `crewName` varchar(50) NOT NULL DEFAULT '',
  `locName` varchar(50) NOT NULL DEFAULT '',
  `x` float(8,4) NOT NULL,
  `y` float(8,4) NOT NULL,
  `z` float(8,4) NOT NULL,
  `rx` float(8,4) NOT NULL,
  `ry` float(8,4) NOT NULL,
  `rz` float(8,4) NOT NULL,
  `scale` float(8,4) unsigned zerofill NOT NULL,
  `text` varchar(32) NOT NULL,
  `font` varchar(32) NOT NULL,
  `color` int(3) NOT NULL,
  `interior` varchar(50) NOT NULL DEFAULT '',
  `created_at` timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- rct.lab_crew_sides: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_sides`;

-- tablo yapısı dökülüyor rct.lab_crew_wars
CREATE TABLE IF NOT EXISTS `lab_crew_wars` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `warSender` varchar(50) DEFAULT NULL,
  `warTarget` varchar(50) DEFAULT NULL,
  `status` varchar(50) NOT NULL DEFAULT 'waiting',
  `date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- rct.lab_crew_wars: ~0 rows (yaklaşık) tablosu için veriler indiriliyor
DELETE FROM `lab_crew_wars`;

/*!40103 SET TIME_ZONE=IFNULL(@OLD_TIME_ZONE, 'system') */;
/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
