Fonts = {}

for idx, f in pairs(FONTS) do
    Fonts[idx] = f.label
end

SprayFont = 1
SprayText = ''
FormattedSprayText = ''

SprayColor = 1

SprayScaleMin = 60
SprayScaleMax = 200
CurrentSprayScale = 40
SprayScale = 1
SprayScaleSelect = {}
SpraySizes = {
    {
        "60"
    },
    {
        "80"
    },
    {
        "100"
    },
    {
        "120"
    },
    {
        "140"
    },
    {
        "150"
    },    
    {
        "200"
    },  
}


for i = SprayScaleMin, SprayScaleMax, 5 do
    table.insert(SprayScaleSelect, i)
end

IsSpraying = false

local lastFormattedText = nil
function ResetFormattedText()
    local tmp = SprayText

    if tmp ~= lastFormattedText then
        lastFormattedText = tmp

        if FONTS[SprayFont].forceUppercase then
            tmp = tmp:upper()
        end

        FormattedSprayText = RemoveDisallowedCharacters(tmp, FONTS[SprayFont].allowedInverse)
    end
end

RegisterNetEvent('lab-crew:spray')
AddEventHandler('lab-crew:spray', function(text)
    if not IsSpraying then
        -- if text then
            -- SprayText = text
            IsSpraying = true
            ResetFormattedText()
            -- WarMenu.OpenMenu('spray')
            sprayColours = {SprayColor}
            simple_sprayColours = {SIMPLE_COLORS}
            SendNUIMessage({
                type = "spray",
                sprayTitle = Utils.Text.MENU.TITLE,
                spraySubTitle = Utils.Text.MENU.SUBTITLE,
                Fonts = Fonts,
                simpleColors = simple_sprayColours, 
                sprayColor = sprayColours,
                SpraySizes = SpraySizes,
                LockInput = Config.SprayLockScreenInput
            })
            SetNuiFocus(true,true)
            SetNuiFocusKeepInput(true)
            LockKeyboards()
        -- else
        --     TriggerEvent('chat:addMessage', {
        --         templateId = 'warning',
        --         args = {Utils.Text.USAGE}
        --     })
        -- end
    end
end, false)

Citizen.CreateThread(function()
    while true do
        Wait(0)

        if IsSpraying then
            -- if WarMenu.IsMenuOpened('spray') then
            --     if WarMenu.ComboBox(Utils.Text.MENU.FONTS, Fonts, SprayFont, SprayFont, function(currentIndex, selectedIndex)
            --         SprayFont = currentIndex
            --         ResetFormattedText()
			-- 	end) then
            --     elseif WarMenu.ColorSelector(Utils.Text.MENU.COLOR, SIMPLE_COLORS, SprayColor, function(i) 
            --         SprayColor = i 
            --     end) then
            --     elseif WarMenu.ComboBox(Utils.Text.MENU.SIZE, SprayScaleSelect, SprayScale, SprayScale, function(currentIndex, selectedIndex)
			-- 		SprayScale = currentIndex
            --     end) then
            --     elseif WarMenu.Button(Utils.Text.MENU.SPRAY) then
            --         WarMenu.CloseMenu()
            --             --! spray yapılan yer ismi ile eğer ki biri sahip değilse ve savaş halinde değilse spray yapılabilecek

            --         if getLocationName() ~= nil then
            --             QBCore.Functions.TriggerCallback('lab-crew:server:checkCrewZones', function (result)
                            
            --                 print('checkCrewZones', json.encode(result))    
            --                 if result then
            --                     PersistSpray()
            --                 end
            --             end, getLocationName())
            --         else
            --             print('yeriniz uygun değil')
            --         end
            --         IsSpraying = false
            --         SprayText = ''
            --     end

            --     WarMenu.Display()
            -- else
            --     IsSpraying = false
            --     SprayText = ''
            -- end
        end
    end
end)




RegisterNUICallback('spraySetText', function (data,cb)
    SprayText = data.textValue
    print('SprayText', SprayText)
    -- while true do
        -- Wait(0)
        ResetFormattedText()
    -- end
end)

RegisterNUICallback('spraySetFont', function (data,cb)
    SprayFont = tonumber(data.selectedFont) + 1
    print('SprayFont', SprayFont)

    ResetFormattedText()
end)

RegisterNUICallback('spraySetColor', function (data,cb)
    SprayColor = tonumber(data.selectedColor) + 1
    print('SprayColor', SprayColor)

    ResetFormattedText()
end)

RegisterNUICallback('spraySetSize', function (data,cb)
    SprayScale = tonumber(data.spraySize) + 1 
    print('SprayScale', SprayScale)
    ResetFormattedText()
end)

RegisterNUICallback('spraying', function (data,cb)
    SetNuiFocus(false, false)
    if getLocationName() ~= nil then
        QBCore.Functions.TriggerCallback('lab-crew:server:checkCrewZones', function (result, enemyCrewTag,locationName)
            
            print('checkCrewZones', json.encode(result))    
            if result then
                PersistSpray(enemyCrewTag,locationName)
            end
        end, getLocationName())
    else
        -- print('yeriniz uygun değil')
        crewNotify(Locales.uCantSprayHere, 'error')
    end
    LockKeyboard = false
    IsSpraying = false
    SprayText = ''
end)

local CustomSettings = {
    settings = {
        handleEnd = Config.SprayHandleEnd;  --Send a result message if true and callback when message closed or callback immediately without showing the message
        speed = Config.SpraySpeed; --pixels / second
        scoreWin = Config.SprayScoreWin; --Score to win
        scoreLose = Config.SprayScoreLose; --Lose if this score is reached
        maxTime = Config.SprayMaxTime; --sec
        maxMistake = Config.SprayMaxMistake; --How many missed keys can there be before losing
        speedIncrement = Config.SpraySpeedIncrement; --How much should the speed increase when a key hit was successful
    },
    keys = Config.SprayKey; 
}


function PersistSpray(enemyCrewTag,locationName)  
    IsSpraying = false
    local rayEndCoords, rayNormal, sprayFwdVector = FindRaycastedSprayCoords()
    if rayEndCoords and rayNormal then
        local sprayLocation = rayEndCoords + sprayFwdVector * SPRAY_FORWARD_OFFSET
        local ped = PlayerPedId()
        local canPos = vector3(0.072, 0.041, -0.06)
        local canRot = vector3(33.0, 38.0, 0.0)
        
        local canObj = CreateObject(
            `ng_proc_spraycan01b`,
            0.0, 0.0, 0.0,
            true, false, false
        )
        AttachEntityToEntity(
            canObj, ped, 
            GetPedBoneIndex(ped, 57005), 
            canPos.x, canPos.y, canPos.z, 
            canRot.x, canRot.y, canRot.z, 
            true, true, false, true, 1, true
        )
        local isCancelled = false
        Citizen.CreateThread(function()
            Wait(2000)
            while not isCancelled do
                SprayEffects()
                Wait(5000)
            end
        end)
        LoadAnimDict('anim@amb@business@weed@weed_inspecting_lo_med_hi@')
        TaskPlayAnim(ped, 'anim@amb@business@weed@weed_inspecting_lo_med_hi@', 'weed_spraybottle_stand_spraying_01_inspector', 1.0, 1.0, -1, 16, 0, 0, 0, 0 )
        local example = exports['cd_keymaster']:StartKeyMaster(CustomSettings)
        if example then
            print('im a winner')
            TriggerServerEvent('lab-crew:addSpray', {
                location = sprayLocation,
                realRotation = currentComputedRotation, 
                scale = (SprayScaleSelect[SprayScale] / 10.0) * FONTS[SprayFont].sizeMult,
                text = FormattedSprayText,
                font = FONTS[SprayFont].font,
                originalColor = SprayColor,
                interior = GetInteriorFromEntity(PlayerPedId()) > 0,
                plyLocation = getLocationName(),
                enemyCrewTag = enemyCrewTag
            })
            ClearPedTasks(ped)
            DeleteObject(canObj)
            isCancelled = true
            LockKeyboard = false
            IsSpraying = false
            SprayText = ''
            SetNuiFocusKeepInput(false)
        else
            LockKeyboard = false
            IsSpraying = false
            SprayText = ''
            ClearPedTasks(ped)
            DeleteObject(canObj)
            isCancelled = true
            SetNuiFocusKeepInput(false)
        end
    end
end

--[[
cut_rcepsilon
  cs_rcepsilon_cola_can
  liquid_splash_paint
  liquid_spray_paint

  /anim  weed_spraybottle_stand_spraying_01_inspector

]]


function SprayEffects()
    local dict = "scr_recartheft"
    local name = "scr_wheel_burnout"
    
    local ped = PlayerPedId()
    local fwd = GetEntityForwardVector(ped)
    local coords = GetEntityCoords(ped) + fwd * 0.5 + vector3(0.0, 0.0, -0.5)

	RequestNamedPtfxAsset(dict)
    -- Wait for the particle dictionary to load.
    while not HasNamedPtfxAssetLoaded(dict) do
        Citizen.Wait(0)
	end

	local pointers = {}
    
    local color = COLORS[SprayColor]['color'].rgb

    local heading = GetEntityHeading(ped)

    UseParticleFxAssetNextCall(dict)
    SetParticleFxNonLoopedColour(color[1] / 255, color[2] / 255, color[3] / 255)
    SetParticleFxNonLoopedAlpha(1.0)
    local ptr = StartNetworkedParticleFxNonLoopedAtCoord(
        name, 
        coords.x, coords.y, coords.z + 2.0, 
        0.0, 0.0, heading, 
        0.7, 
        0.0, 0.0, 0.0
    )
    RemoveNamedPtfxAsset(dict)
end

function loadAnimDict( dict )
    while ( not HasAnimDictLoaded( dict ) ) do
        RequestAnimDict( dict )
        Citizen.Wait( 100 )
    end
end

function RemoveDisallowedCharacters(str, inverse)
    local replaced, _ = str:gsub(inverse, '')

    return replaced
end




LockKeyboard = false

LockKeyboards = function ()
    LockKeyboard = true

    while true do
        Citizen.Wait(5)
        if LockKeyboard then            
            playerPed = PlayerPedId()
            DisablePlayerFiring(playerPed, true)
            SetPedCanPlayGestureAnims(playerPed, false)
            DisableControlAction(0, 24, true) -- Attack
            DisableControlAction(0, 257, true) -- Attack 2
            DisableControlAction(0, 25, true) -- Aim
            DisableControlAction(0, 263, true) -- Melee Attack 1
            DisableControlAction(0, 45, true) -- Reload
            DisableControlAction(0, 21, true) -- left shift
            DisableControlAction(0, 22, true) -- Jump
            DisableControlAction(0, 23, true) -- F
            DisableControlAction(0, 182, true) -- L
            DisableControlAction(0, 80, true) -- R
            DisableControlAction(0, 311, true) -- K
            DisableControlAction(0, 26, true) -- C
            DisableControlAction(0, 75, true) -- F
            DisableControlAction(0, 157, true)
            DisableControlAction(0, 158, true)
            DisableControlAction(0, 160, true)
            DisableControlAction(0, 164, true)
            DisableControlAction(0, 165, true)
            DisableControlAction(0, 44, true) -- Cover
            DisableControlAction(0, 37, true) -- Select Weapon
            DisableControlAction(0, 288,  true) -- Disable phone
            DisableControlAction(0, 245,  true) -- Disable chat
            DisableControlAction(0, 289, true) -- Inventory
            DisableControlAction(0, 170, true) -- Animations
            DisableControlAction(0, 167, true) -- Job
            DisableControlAction(0, 244, true) -- Ragdoll
            DisableControlAction(0, 303, true) -- Car lock
            DisableControlAction(0, 29, true) -- B ile işaret
            DisableControlAction(0, 81, true) -- B ile işaret
            DisableControlAction(0, 26, true) -- Disable looking behind
            DisableControlAction(0, 73, true) -- Disable clearing animation
            DisableControlAction(2, 199, true) -- Disable pause screen
            DisableControlAction(2, 36, true) -- Disable going stealth
            DisableControlAction(0, 47, true)  -- Disable weapon
            DisableControlAction(0, 264, true) -- Disable melee
            DisableControlAction(0, 257, true) -- Disable melee
            DisableControlAction(0, 140, true) -- Disable melee
            DisableControlAction(0, 141, true) -- Disable melee
            DisableControlAction(0, 142, true) -- Disable melee
        end
    end
end
